Index: LMDZ5/trunk/libf/dyn3dmem/massbar_loc.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/massbar_loc.F90	(revision 2336)
+++ LMDZ5/trunk/libf/dyn3dmem/massbar_loc.F90	(revision 2336)
@@ -0,0 +1,76 @@
+SUBROUTINE massbar_loc(masse,massebx,masseby)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse  (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: massebx(ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: masseby(ijb_v:ije_v,llm)
+!-------------------------------------------------------------------------------
+! Method used. Each scalar point is associated to 4 area coefficients:
+!    * alpha1(i,j) at point ( i+1/4,j-1/4 )
+!    * alpha2(i,j) at point ( i+1/4,j+1/4 )
+!    * alpha3(i,j) at point ( i-1/4,j+1/4 )
+!    * alpha4(i,j) at point ( i-1/4,j-1/4 )
+! where alpha1(i,j) = aire(i+1/4,j-1/4)/ aire(i,j)
+!
+!   alpha4 .         . alpha1    . alpha4
+!    (i,j)             (i,j)       (i+1,j)
+!
+!             P .        U .          . P
+!           (i,j)       (i,j)         (i+1,j)
+!
+!   alpha3 .         . alpha2    .alpha3 
+!    (i,j)              (i,j)     (i+1,j)
+!
+!             V .        Z .          . V
+!           (i,j)
+!
+!   alpha4 .         . alpha1    .alpha4
+!   (i,j+1)            (i,j+1)   (i+1,j+1) 
+!
+!             P .        U .          . P
+!          (i,j+1)                    (i+1,j+1)
+!
+!
+!    massebx(i,j) = masse(i  ,j) * ( alpha1(i  ,j) + alpha2(i,j))   +
+!                   masse(i+1,j) * ( alpha3(i+1,j) + alpha4(i+1,j) )
+!     localized at point  ... U (i,j) ...
+!
+!    masseby(i,j) = masse(i,j  ) * ( alpha2(i,j  ) + alpha3(i,j  )  +
+!                   masse(i,j+1) * ( alpha1(i,j+1) + alpha4(i,j+1)  
+!     localized at point  ... V (i,j) ...
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l, ijb, ije
+!===============================================================================
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)  
+  DO l=1,llm
+    ijb=ij_begin
+    ije=ij_end+iip1
+    IF(pole_sud) ije=ije-iip1
+    DO ij=ijb,ije-1
+      massebx(ij,l)=masse(ij,l)*alpha1p2(ij)+masse(ij+1   ,l)*alpha3p4(ij+1)
+    END DO
+    DO ij=ijb+iim,ije+iim,iip1; massebx(ij,l)=massebx(ij-iim,l); END DO
+    ijb=ij_begin-iip1
+    ije=ij_end+iip1
+    IF(pole_nord) ijb=ij_begin
+    IF(pole_sud) ije=ij_end-iip1
+    DO ij=ijb,ije
+      masseby(ij,l)=masse(ij,l)*alpha2p3(ij)+masse(ij+iip1,l)*alpha1p4(ij+iip1)
+    END DO
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE massbar_loc
+
Index: LMDZ5/trunk/libf/dyn3dmem/massbarxy_loc.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/massbarxy_loc.F90	(revision 2336)
+++ LMDZ5/trunk/libf/dyn3dmem/massbarxy_loc.F90	(revision 2336)
@@ -0,0 +1,39 @@
+SUBROUTINE massbarxy_loc(masse,massebxy)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute air mass mean along X and Y in each cell.
+! See iniconst for more details.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comconst.h"
+  include "comgeom.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: masse   (ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: massebxy(ijb_v:ije_v,llm)
+!===============================================================================
+! Local variables:
+  INTEGER :: ij, l, ijb, ije
+!===============================================================================
+  ijb=ij_begin-iip1
+  ije=ij_end
+  IF(pole_nord) ijb=ijb+iip1
+  IF(pole_sud)  ije=ije-iip1
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)    
+  DO l=1,llm
+    DO ij=ijb,ije-1
+      massebxy(ij,l)=masse(ij     ,l)*alpha2(ij     ) + &
+     +               masse(ij+1   ,l)*alpha3(ij+1   ) + &
+     +               masse(ij+iip1,l)*alpha1(ij+iip1) + &
+     +               masse(ij+iip2,l)*alpha4(ij+iip2)
+    END DO
+    DO ij=ijb+iip1-1,ije+iip1-1,iip1; massebxy(ij,l)=massebxy(ij-iim,l); END DO
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE massbarxy_loc
+
Index: LMDZ5/trunk/libf/dyn3dmem/tourpot_loc.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/tourpot_loc.F90	(revision 2336)
+++ LMDZ5/trunk/libf/dyn3dmem/tourpot_loc.F90	(revision 2336)
@@ -0,0 +1,65 @@
+SUBROUTINE tourpot_loc ( vcov, ucov, massebxy, vorpot )
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van.
+!-------------------------------------------------------------------------------
+! Purpose: Compute potential vorticity.
+  USE parallel_lmdz
+  USE mod_filtreg_p
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comgeom.h"
+  include "logic.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: vcov    (ijb_v:ije_v,llm)
+  REAL, INTENT(IN)  :: ucov    (ijb_u:ije_u,llm)
+  REAL, INTENT(IN)  :: massebxy(ijb_v:ije_v,llm)
+  REAL, INTENT(OUT) :: vorpot  (ijb_v:ije_v,llm)
+!===============================================================================
+! Method used:
+!   vorpot = ( Filtre( d(vcov)/dx - d(ucov)/dy ) + fext ) /psbarxy
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ij, ije, ijb, jje, jjb
+  REAL    :: rot(ijb_v:ije_v,llm)
+!===============================================================================
+
+  ijb=ij_begin-iip1
+  ije=ij_end
+  IF(pole_nord) ijb=ij_begin
+
+!--- Wind vorticity ; correction: rot(iip1,j,l) = rot(1,j,l)
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,llm
+    IF(pole_sud) ije=ij_end-iip1-1
+    DO ij=ijb,ije
+      rot(ij,l)=vcov(ij+1,l)-vcov(ij,l)+ucov(ij+iip1,l)-ucov(ij,l)
+    END DO
+    IF(pole_sud) ije=ij_end-iip1
+    DO ij=ijb+iip1-1,ije,iip1; rot(ij,l)=rot(ij-iim,l); END DO
+  END DO
+!$OMP END DO NOWAIT
+
+!--- Filter
+  jjb=jj_begin-1
+  jje=jj_end
+  IF(pole_nord) jjb=jjb+1
+  IF(pole_sud)  jje=jje-1
+  CALL filtreg_p(rot,jjb_v,jje_v,jjb,jje,jjm,llm,2,1,.FALSE.,1)
+
+!--- Potential vorticity ; correction: rot(iip1,j,l) = rot(1,j,l)
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
+  DO l=1,llm
+    IF(pole_sud) ije=ij_end-iip1-1
+    DO ij=ijb,ije
+      vorpot(ij,l)=(rot(ij,l)+fext(ij))/massebxy(ij,l)
+    END DO
+    IF(pole_sud) ije=ij_end-iip1
+    DO ij=ijb+iip1-1,ije,iip1; vorpot(ij,l)=vorpot(ij-iim,l); END DO
+  END DO
+!$OMP END DO NOWAIT
+
+END SUBROUTINE tourpot_loc
+
Index: LMDZ5/trunk/libf/dyn3dmem/vitvert_loc.F90
===================================================================
--- LMDZ5/trunk/libf/dyn3dmem/vitvert_loc.F90	(revision 2336)
+++ LMDZ5/trunk/libf/dyn3dmem/vitvert_loc.F90	(revision 2336)
@@ -0,0 +1,38 @@
+SUBROUTINE vitvert_loc(convm, w)
+!
+!-------------------------------------------------------------------------------
+! Authors: P. Le Van , Fr. Hourdin.
+!-------------------------------------------------------------------------------
+! Purpose: Compute vertical speed at sigma levels.
+  USE parallel_lmdz
+  IMPLICIT NONE
+  include "dimensions.h"
+  include "paramet.h"
+  include "comvert.h"
+!===============================================================================
+! Arguments:
+  REAL, INTENT(IN)  :: convm(ijb_u:ije_u,llm)
+  REAL, INTENT(OUT) :: w    (ijb_u:ije_u,llm)
+!===============================================================================
+! Notes: Vertical speed is oriented from bottom to top.
+!   * At ground - level sigma(1):     w(i,j,1) = 0.
+!   * At top    - level sigma(llm+1): w(i,j,l) = 0. (not stored in w)
+!===============================================================================
+! Local variables:
+  INTEGER :: l, ijb, ije
+!===============================================================================
+  ijb=ij_begin
+  ije=ij_end+iip1
+  IF(pole_sud) ije=ij_end
+!$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
+  DO l=1,llmm1
+    w(ijb:ije,l+1)=convm(ijb:ije,l+1)-bp(l+1)*convm(ijb:ije,1)
+  END DO
+!$OMP END DO
+!$OMP MASTER
+  w(ijb:ije,1)=0.
+!$OMP END MASTER
+!$OMP BARRIER
+
+END SUBROUTINE vitvert_loc
+
Index: LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/ce0l.F90
===================================================================
--- LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/ce0l.F90	(revision 2335)
+++ LMDZ5/trunk/libf/dynlonlat_phylonlat/phylmd/ce0l.F90	(revision 2336)
@@ -1,28 +1,46 @@
 PROGRAM ce0l
-  !
-  ! Purpose: Calls etat0, creates initial states and limit_netcdf
-  !
-  ! interbar=.T. for barycentric interpolation inter_barxy
-  ! extrap  =.T. for data extrapolation, like for the SSTs when file does not
-  !                  contain ocean points only.
-  ! oldice  =.T. for old-style ice, obtained using grille_m (grid_atob).
-  ! masque is created in etat0, passed to limit to ensure consistancy.
-
-  USE control_mod, only: DAY_STEP, DAYREF, NSPLIT_PHYS
-  USE etat0dyn, only: etat0dyn_netcdf
-  USE netcdf, ONLY: NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR
+!
+!-------------------------------------------------------------------------------
+! Purpose: Initial states and boundary conditions files creation:
+!     * start.nc    for dynamics    (using etat0dyn     routine)
+!     * startphy.nc for physics     (using etat0phys    routine)
+!     * limit.nc    for forced runs (using limit_netcdf routine)
+!-------------------------------------------------------------------------------
+! Notes:
+!     * extrap=.T. (default) for data extrapolation, like for the SSTs when file
+!                   does contain ocean points only.
+!     * "masque" can be:
+!       - read from file "o2a.nc"          (for coupled runs).
+!       - created in etat0phys or etat0dyn (for forced  runs).
+!     It is then passed to limit_netcdf to ensure consistancy.
+!-------------------------------------------------------------------------------
   USE ioipsl, ONLY: ioconf_calendar, getin, flininfo, flinopen, flinget, flinclo
-
-  USE etat0phys, only: etat0phys_netcdf
-  USE dimphy, only: KLON
-  USE infotrac, only: TYPE_TRAC, infotrac_init
+  USE control_mod,    ONLY: day_step, dayref, nsplit_phys
+  USE etat0dyn,       ONLY: etat0dyn_netcdf
+  USE etat0phys,      ONLY: etat0phys_netcdf
+  USE limit,          ONLY: limit_netcdf
+  USE netcdf,         ONLY: NF90_OPEN, NF90_NOWRITE, NF90_CLOSE, NF90_NOERR
+  USE infotrac,       ONLY: type_trac, infotrac_init
+  USE dimphy,         ONLY: klon
   USE test_disvert_m, ONLY: test_disvert
+  USE filtreg_mod,    ONLY: inifilr
+#ifdef inca
+  USE indice_sol_mod, ONLY: nbsrf, is_oce, is_sic, is_ter, is_lic
+#endif
+#ifdef CPP_PARA
+  USE mod_const_mpi,  ONLY: init_const_mpi
+  USE parallel_lmdz,  ONLY: init_parallel, mpi_rank, omp_rank, mpi_size
+  USE bands,          ONLY: read_distrib, distrib_phys
+  USE mod_hallo,      ONLY: init_mod_hallo
+  USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
+#endif
 
   IMPLICIT NONE
 
-  ! Local variables:
+!-------------------------------------------------------------------------------
+! Local variables:
   include "dimensions.h"
   include "paramet.h"
-  include "comgeom.h"
+  include "comgeom2.h"
   include "comconst.h"
   include "comvert.h"
@@ -30,21 +48,20 @@
   include "temps.h"
   include "logic.h"
-  REAL               :: masque(iip1, jjp1)             !--- CONTINENTAL MASK
-  REAL               :: phis  (iip1, jjp1)             !--- GROUND GEOPOTENTIAL
+  REAL               :: masque(iip1,jjp1)             !--- CONTINENTAL MASK
+  REAL               :: phis  (iip1,jjp1)             !--- GROUND GEOPOTENTIAL
   CHARACTER(LEN=256) :: modname, fmt, calnd           !--- CALENDAR TYPE
   LOGICAL            :: use_filtre_fft
-  LOGICAL, PARAMETER :: interbar=.TRUE., extrap=.FALSE., oldice=.FALSE.
-
-  !--- Local variables for ocean mask reading:
+  LOGICAL, PARAMETER :: extrap=.FALSE.
+
+!--- Local variables for ocean mask reading:
   INTEGER            :: nid_o2a, iml_omask, jml_omask, j
   INTEGER            :: fid, iret, llm_tmp, ttm_tmp, itaul(1)
-  REAL, ALLOCATABLE  :: lon_omask(:, :), dlon_omask(:), ocemask(:, :)
-  REAL, ALLOCATABLE  :: lat_omask(:, :), dlat_omask(:), ocetmp (:, :)
+  REAL, ALLOCATABLE  :: lon_omask(:,:), dlon_omask(:), ocemask(:,:)
+  REAL, ALLOCATABLE  :: lat_omask(:,:), dlat_omask(:), ocetmp (:,:)
   REAL               :: date, lev(1)
-
-  !----------------------------------------------------------------------
+!-------------------------------------------------------------------------------
   modname="ce0l"
 
-  !--- Constants
+!--- Constants
   pi     = 4. * ATAN(1.)
   rad    = 6371229.
@@ -59,145 +76,146 @@
 
   CALL conf_gcm( 99, .TRUE. )
-
   dtvr = daysec/REAL(day_step)
-  WRITE(lunout, *)'dtvr', dtvr
-
+  WRITE(lunout,*)'dtvr',dtvr
   CALL iniconst()
   CALL inigeom()
 
+!--- Calendar choice
 #ifdef CPP_IOIPSL
   calnd='gregorian'
   SELECT CASE(calend)
-  CASE('earth_360d')
-     CALL ioconf_calendar('360d')
-     calnd='with 360 days/year'
-  CASE('earth_365d')
-     CALL ioconf_calendar('noleap')
-     calnd='with no leap year'
-  CASE('earth_366d')
-     CALL ioconf_calendar('366d')
-     calnd='with leap years only'
-  CASE('gregorian')
-     CALL ioconf_calendar('gregorian')
-  CASE('standard')
-     CALL ioconf_calendar('gregorian')
-  CASE('julian')
-     CALL ioconf_calendar('julian')
-     calnd='julian'
-  CASE('proleptic_gregorian')
-     CALL ioconf_calendar('gregorian')
-     !--- DC Bof...  => IOIPSL a mettre a jour: proleptic_gregorian /= gregorian
-  CASE DEFAULT
-     CALL abort_gcm('ce0l', 'Bad choice for calendar', 1)
+    CASE('earth_360d');CALL ioconf_calendar('360d');   calnd='with 360 days/year'
+    CASE('earth_365d');CALL ioconf_calendar('noleap'); calnd='with no leap year'
+    CASE('earth_366d');CALL ioconf_calendar('366d');   calnd='with leap years only'
+    CASE('gregorian'); CALL ioconf_calendar('gregorian')
+    CASE('standard');  CALL ioconf_calendar('gregorian')
+    CASE('julian');    CALL ioconf_calendar('julian'); calnd='julian'
+    CASE('proleptic_gregorian'); CALL ioconf_calendar('gregorian')
+  !--- DC Bof...  => IOIPSL a mettre a jour: proleptic_gregorian /= gregorian
+    CASE DEFAULT
+      CALL abort_gcm('ce0l','Bad choice for calendar',1)
   END SELECT
-  WRITE(lunout, *)'CHOSEN CALENDAR: Earth '//TRIM(calnd)
-#endif
-
-  use_filtre_fft=.FALSE.
-  CALL getin('use_filtre_fft', use_filtre_fft)
-  IF(use_filtre_fft) THEN
-     WRITE(lunout, *)"FFT filter not available for sequential dynamics."
-     WRITE(lunout, *)"Your setting of variable use_filtre_fft is not used."
-  ENDIF
-
-  !--- LAND MASK. TWO CASES:
-  !   1) read from ocean model    file "o2a.nc"    (coupled runs)
-  !   2) computed from topography file "Relief.nc" (masque(:, :)=-99999.)
-  ! Coupled simulations (case 1) use the ocean model mask to compute the
-  ! weights to ensure ocean fractions are the same for atmosphere and ocean.
-
-  IF(NF90_OPEN("o2a.nc", NF90_NOWRITE, nid_o2a)/=NF90_NOERR) THEN
-     WRITE(lunout, *)'BEWARE !! No ocean mask "o2a.nc" file found'
-     WRITE(lunout, *)'Forced run.'
-     masque(:, :)=-99999.
-  ELSE
-     iret=NF90_CLOSE(nid_o2a)
-     WRITE(lunout, *)'BEWARE !! Ocean mask "o2a.nc" file found'
-     WRITE(lunout, *)'Coupled run.'
-     CALL flininfo("o2a.nc", iml_omask, jml_omask, llm_tmp, ttm_tmp, nid_o2a)
-     IF(iml_omask/=iim .OR.jml_omask/=jjp1) THEN
-        WRITE(lunout, *)'Mismatching dimensions for ocean mask'
-        WRITE(lunout, *)'iim  = ', iim , ' iml_omask = ', iml_omask
-        WRITE(lunout, *)'jjp1 = ', jjp1, ' jml_omask = ', jml_omask
-        CALL abort_gcm(modname, '', 1)
-     END IF
-     ALLOCATE(ocemask(iim, jjp1), lon_omask(iim, jjp1), dlon_omask(iim ))
-     ALLOCATE(ocetmp (iim, jjp1), lat_omask(iim, jjp1), dlat_omask(jjp1))
-     CALL flinopen("o2a.nc", .FALSE., iim, jjp1, llm_tmp, lon_omask, &
-          lat_omask, lev, ttm_tmp, itaul, date, dt, fid)
-     CALL flinget(fid, "OceMask",    iim, jjp1, llm_tmp, ttm_tmp, 1, 1, ocetmp)
-     CALL flinclo(fid)
-     dlon_omask(1:iim ) = lon_omask(1:iim, 1)
-     dlat_omask(1:jjp1) = lat_omask(1, 1:jjp1)
-     ocemask = ocetmp
-     IF(dlat_omask(1)<dlat_omask(jml_omask)) THEN
-        DO j=1, jjp1
-           ocemask(:, j) = ocetmp(:, jjp1-j+1)
-        END DO
-     END IF
-     DEALLOCATE(ocetmp, lon_omask, lat_omask, dlon_omask, dlat_omask)
-     IF(prt_level>=1) THEN
-        WRITE(fmt, "(i4, 'i1)')")iim 
-        fmt='('//ADJUSTL(fmt)
-        WRITE(lunout, *)'OCEAN MASK :'
-        WRITE(lunout, fmt) NINT(ocemask)
-     END IF
-     masque(1:iim, :)=1.-ocemask(:, :)
-     masque(iip1 , :)=masque(1, :)
-     DEALLOCATE(ocemask)
-  END IF
-  phis(:, :)=-99999.
-
-  CALL Init_Phys_lmdz(iim, jjp1, llm, 1, (/(jjm-1)*iim+2/))
-  WRITE(lunout, *)'---> klon=', klon
-
-  call infotrac_init
-  CALL iniphysiq(iim, jjm, llm, daysec, dayref, dtphys / nsplit_phys, rlatu, &
-       rlonv, aire, cu, cv, rad, g, r, cpp, iflag_phys)
-
-  IF(pressure_exner) CALL test_disvert
-
+  WRITE(lunout,*)'CHOSEN CALENDAR: Earth '//TRIM(calnd)
+#endif
+
+#ifdef CPP_PARA
+!--- Physical grid + parallel initializations
+  CALL init_const_mpi()
+  CALL init_parallel()
+  CALL read_distrib()
+  CALL init_mod_hallo()
+  CALL Init_Phys_lmdz(iim,jjp1,llm,mpi_size,distrib_phys)
+  CALL init_interface_dyn_phys()
+#else
+  CALL Init_Phys_lmdz(iim,jjp1,llm,1,(/(jjm-1)*iim+2/))
+#endif
+  WRITE(lunout,*)'---> klon=',klon
+
+!--- Tracers initializations
   IF (type_trac == 'inca') THEN
 #ifdef INCA
-     CALL init_const_lmdz(nbtr, anneeref, dayref, iphysiq, day_step, nday)
-     CALL init_inca_para(iim, jjm+1, klon, 1, klon_mpi_para_nb, 0)
-     WRITE(lunout, *)'nbtr =' , nbtr 
-#endif
-  END IF
+    CALL init_const_lmdz(nbtr,anneeref,dayref,iphysiq,day_step,nday,&
+                         nbsrf,is_oce,is_sic,is_ter,is_lic,calend)
+    CALL init_inca_para(iim,jjp1,llm,klon_glo,mpi_size,distrib_phys,&
+                        COMM_LMDZ)
+    WRITE(lunout,*)'nbtr =' , nbtr 
+#endif
+  END IF
+  CALL infotrac_init()
+
+  CALL inifilr()
+  CALL iniphysiq(iim,jjm,llm,daysec,day_ini,dtphys/nsplit_phys, &
+                 rlatu,rlonv,aire,cu,cv,rad,g,r,cpp,iflag_phys)
+  IF(pressure_exner) CALL test_disvert
+
+#ifdef CPP_PARA
+  IF (mpi_rank==0.AND.omp_rank==0) THEN
+#endif
+  use_filtre_fft=.FALSE.
+  CALL getin('use_filtre_fft',use_filtre_fft)
+  IF(use_filtre_fft) THEN
+     WRITE(lunout,*)"FFT filter not available for sequential dynamics."
+     WRITE(lunout,*)"Your setting of variable use_filtre_fft is not used."
+  ENDIF
+
+!--- LAND MASK. TWO CASES:
+!   1) read from ocean model    file "o2a.nc"    (coupled runs)
+!   2) computed from topography file "Relief.nc" (masque(:,:)=-99999.)
+! Coupled simulations (case 1) use the ocean model mask to compute the
+! weights to ensure ocean fractions are the same for atmosphere and ocean.
+!*******************************************************************************
+  IF(NF90_OPEN("o2a.nc", NF90_NOWRITE, nid_o2a)/=NF90_NOERR) THEN
+    WRITE(lunout,*)'BEWARE !! No ocean mask "o2a.nc" file found'
+    WRITE(lunout,*)'Forced run.'
+    masque(:,:)=-99999.
+  ELSE
+    iret=NF90_CLOSE(nid_o2a)
+    WRITE(lunout,*)'BEWARE !! Ocean mask "o2a.nc" file found'
+    WRITE(lunout,*)'Coupled run.'
+    CALL flininfo("o2a.nc", iml_omask, jml_omask, llm_tmp, ttm_tmp, nid_o2a)
+    IF(iml_omask/=iim .OR.jml_omask/=jjp1) THEN
+      WRITE(lunout,*)'Mismatching dimensions for ocean mask'
+      WRITE(lunout,*)'iim  = ',iim ,' iml_omask = ',iml_omask
+      WRITE(lunout,*)'jjp1 = ',jjp1,' jml_omask = ',jml_omask
+      CALL abort_gcm(modname,'',1)
+    END IF
+    ALLOCATE(ocemask(iim,jjp1),lon_omask(iim,jjp1),dlon_omask(iim ))
+    ALLOCATE(ocetmp (iim,jjp1),lat_omask(iim,jjp1),dlat_omask(jjp1))
+    CALL flinopen("o2a.nc", .FALSE.,iim,jjp1,llm_tmp,lon_omask,lat_omask,lev,  &
+     &                                       ttm_tmp,itaul,date,dt,fid)
+    CALL flinget(fid, "OceMask",    iim,jjp1,llm_tmp,ttm_tmp,1,1,ocetmp)
+    CALL flinclo(fid)
+    dlon_omask(1:iim ) = lon_omask(1:iim,1)
+    dlat_omask(1:jjp1) = lat_omask(1,1:jjp1)
+    ocemask = ocetmp
+    IF(dlat_omask(1)<dlat_omask(jml_omask)) THEN
+      DO j=1,jjp1; ocemask(:,j) = ocetmp(:,jjp1-j+1); END DO
+    END IF
+    DEALLOCATE(ocetmp,lon_omask,lat_omask,dlon_omask,dlat_omask)
+    IF(prt_level>=1) THEN
+      WRITE(fmt,"(i4,'i1)')")iim ; fmt='('//ADJUSTL(fmt)
+      WRITE(lunout,*)'OCEAN MASK :'
+      WRITE(lunout,fmt) NINT(ocemask)
+    END IF
+    masque(1:iim,:)=1.-ocemask(:,:)
+    masque(iip1 ,:)=masque(1,:)
+    DEALLOCATE(ocemask)
+  END IF
+  phis(:,:)=-99999.
+
   IF(ok_etat0) THEN
-     WRITE(lunout, '(//)')
-     WRITE(lunout, *) '  ************************  '
-     WRITE(lunout, *) '  ***  etat0phy_netcdf ***  '
-     WRITE(lunout, *) '  ************************  '
-     WRITE(lunout, '(//)')
-     WRITE(lunout, *) ' interbar = ', interbar
-     CALL etat0phys_netcdf(interbar, masque, phis)
-  END IF
-
-  IF(ok_etat0) THEN
-     WRITE(lunout, '(//)')
-     WRITE(lunout, *) '  ************************  '
-     WRITE(lunout, *) '  ***  etat0dyn_netcdf ***  '
-     WRITE(lunout, *) '  ************************  '
-     WRITE(lunout, '(//)')
-     WRITE(lunout, *) ' interbar = ', interbar
-     CALL etat0dyn_netcdf(interbar, masque, phis)
+    WRITE(lunout,'(//)')
+    WRITE(lunout,*) '  ************************  '
+    WRITE(lunout,*) '  ***  etat0phy_netcdf ***  '
+    WRITE(lunout,*) '  ************************  '
+    CALL etat0phys_netcdf(masque,phis)
+    WRITE(lunout,'(//)')
+    WRITE(lunout,*) '  ************************  '
+    WRITE(lunout,*) '  ***  etat0dyn_netcdf ***  '
+    WRITE(lunout,*) '  ************************  '
+    CALL etat0dyn_netcdf(masque,phis)
   END IF
 
   IF(ok_limit) THEN
-     WRITE(lunout, '(//)')
-     WRITE(lunout, *) '  *********************  '
-     WRITE(lunout, *) '  ***  Limit_netcdf ***  '
-     WRITE(lunout, *) '  *********************  '
-     WRITE(lunout, '(//)')
-     CALL limit_netcdf(interbar, extrap, oldice, masque)
-  END IF
-
-  WRITE(lunout, '(//)')
-  WRITE(lunout, *) '  ***************************  '
-  WRITE(lunout, *) '  ***  grilles_gcm_netcdf ***  '
-  WRITE(lunout, *) '  ***************************  '
-  WRITE(lunout, '(//)')
-  CALL grilles_gcm_netcdf_sub(masque, phis)
+    WRITE(lunout,'(//)')
+    WRITE(lunout,*) '  *********************  '
+    WRITE(lunout,*) '  ***  Limit_netcdf ***  '
+    WRITE(lunout,*) '  *********************  '
+    WRITE(lunout,'(//)')
+    CALL limit_netcdf(masque,phis,extrap)
+  END IF
+
+  WRITE(lunout,'(//)')
+  WRITE(lunout,*) '  ***************************  '
+  WRITE(lunout,*) '  ***  grilles_gcm_netcdf ***  '
+  WRITE(lunout,*) '  ***************************  '
+  WRITE(lunout,'(//)')
+  CALL grilles_gcm_netcdf_sub(masque,phis)
+
+#ifdef CPP_PARA
+  END IF
+#endif
 
 END PROGRAM ce0l
+!
+!-------------------------------------------------------------------------------
